package com.fossgalaxy.games.tbs.editor;

import com.fossgalaxy.games.tbs.editor.EditorView.EditorModel;
import com.fossgalaxy.games.tbs.editor.EditorView.EditorView;
import com.fossgalaxy.games.tbs.io.map2.EntityDef;
import com.fossgalaxy.games.tbs.io.map2.MapDef;
import org.codetome.hexameter.core.api.CubeCoordinate;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

public class EditorMouseController implements MouseListener {

    private EditorView view;
    private EditorModel model;

    public EditorMouseController(EditorView view, EditorModel model) {
        this.view = view;
        this.model = model;
    }

    @Override
    public void mouseClicked(MouseEvent mouseEvent) {
        MapDef def = model.getDef();
        if (def == null){
            return;
        }

        CubeCoordinate location = model.pix2cube(mouseEvent.getPoint());

        // Left click select, right click move

        if (mouseEvent.getButton() == MouseEvent.BUTTON1) {
            EntityDef entityDef = def.getEntityAtLocation(location);
            if (entityDef != null && !mouseEvent.isAltDown()) {
                model.setEntityDef(entityDef);
            } else {
                model.setSelected(location);
            }
            view.repaint();
        }

        view.repaint();
    }

    @Override
    public void mousePressed(MouseEvent mouseEvent) {

    }

    @Override
    public void mouseReleased(MouseEvent mouseEvent) {

    }

    @Override
    public void mouseEntered(MouseEvent mouseEvent) {

    }

    @Override
    public void mouseExited(MouseEvent mouseEvent) {

    }

}
