package com.fossgalaxy.games.tbs.editor;

import com.fossgalaxy.games.tbs.editor.EditorView.EditorModel;
import com.fossgalaxy.games.tbs.io.SettingsIO;
import com.fossgalaxy.games.tbs.io.map2.MapDef;

import javax.swing.*;
import java.awt.event.ActionEvent;

public class OpenAction extends AbstractAction {
    private SettingsIO io;
    private EditorModel model;

    public OpenAction(SettingsIO io, EditorModel model) {
        super("open");
        this.io = io;
        this.model = model;
    }

    @Override
    public void actionPerformed(ActionEvent actionEvent) {

        JFileChooser fc = new JFileChooser();
        int ret = fc.showOpenDialog(null);

        if (ret == JFileChooser.APPROVE_OPTION) {
        	
            MapDef def = io.loadMapDef(fc.getSelectedFile().getAbsolutePath());
            model.setMapDef(def);
        }

    }
}
